Public Class Form1
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents TextBox1 As System.Windows.Forms.TextBox

    'Required by the Windows Form Designer
    Private components As System.ComponentModel.IContainer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.TextBox1 = New System.Windows.Forms.TextBox()
        Me.SuspendLayout()
        '
        'TextBox1
        '
        Me.TextBox1.Dock = System.Windows.Forms.DockStyle.Fill
        Me.TextBox1.Multiline = True
        Me.TextBox1.Name = "TextBox1"
        Me.TextBox1.Size = New System.Drawing.Size(542, 214)
        Me.TextBox1.TabIndex = 0
        Me.TextBox1.Text = ""
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(6, 15)
        Me.ClientSize = New System.Drawing.Size(542, 214)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.TextBox1})
        Me.Name = "Form1"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = "Late binding Performance Test"
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        Dim before, after As DateTime
        Dim lateElapsed, earlyElapsed As Double

        Dim text As New System.Text.StringBuilder()

        before = Now()
        LateBindingTest(TextBox1)
        after = Now()

        lateElapsed = (after.Ticks - before.Ticks) / Math.Pow(10, 7)
        text.AppendFormat("LateBindingTest Function: {0}s{1}", lateElapsed, vbCrLf)

        before = Now()
        EarlyBindingTest(TextBox1)
        after = Now()

        earlyElapsed = (after.Ticks - before.Ticks) / Math.Pow(10, 7)
        text.AppendFormat("EarlyBindingTest Function: {0}s{1}", earlyElapsed, vbCrLf)

        text.AppendFormat("Early binding is {0} times faster than late binding{1}", (lateElapsed / earlyElapsed), vbCrLf)

        TextBox1.Text = text.ToString()
    End Sub

    Private Sub LateBindingTest(ByVal obj As Object)
        Dim i As Integer
        For i = 0 To 1000
            obj.Text = "Late Binding Test"
        Next
    End Sub

    Private Sub EarlyBindingTest(ByVal obj As TextBox)
        Dim i As Integer
        For i = 0 To 1000
            obj.Text = "Early Binding Test"
        Next
    End Sub

    Private Sub TextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox1.TextChanged

    End Sub
End Class
