Option Strict Off
Option Explicit On
Imports VB = Microsoft.VisualBasic
Friend Class Form1
	Inherits System.Windows.Forms.Form
#Region "Windows Form Designer generated code "
	Public Sub New()
		MyBase.New()
		If m_vb6FormDefInstance Is Nothing Then
			If m_InitializingDefInstance Then
				m_vb6FormDefInstance = Me
			Else
				Try 
					'For the start-up form, the first instance created is the default instance.
					If System.Reflection.Assembly.GetExecutingAssembly.EntryPoint.DeclaringType Is Me.GetType Then
						m_vb6FormDefInstance = Me
					End If
				Catch
				End Try
			End If
		End If
		'This call is required by the Windows Form Designer.
		InitializeComponent()
	End Sub
	'Form overrides dispose to clean up the component list.
	Protected Overloads Overrides Sub Dispose(ByVal Disposing As Boolean)
		If Disposing Then
			If Not components Is Nothing Then
				components.Dispose()
			End If
		End If
		MyBase.Dispose(Disposing)
	End Sub
	'Required by the Windows Form Designer
	Private components As System.ComponentModel.IContainer
	Public ToolTip1 As System.Windows.Forms.ToolTip
	Public WithEvents PictureDisplay As System.Windows.Forms.PictureBox
	Public WithEvents FileList As System.Windows.Forms.ListBox
	'NOTE: The following procedure is required by the Windows Form Designer
	'It can be modified using the Windows Form Designer.
	'Do not modify it using the code editor.
	<System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Me.ToolTip1 = New System.Windows.Forms.ToolTip(Me.components)
        Me.PictureDisplay = New System.Windows.Forms.PictureBox()
        Me.FileList = New System.Windows.Forms.ListBox()
        Me.SuspendLayout()
        '
        'PictureDisplay
        '
        Me.PictureDisplay.BackColor = System.Drawing.SystemColors.Control
        Me.PictureDisplay.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D
        Me.PictureDisplay.Cursor = System.Windows.Forms.Cursors.Default
        Me.PictureDisplay.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.PictureDisplay.ForeColor = System.Drawing.SystemColors.ControlText
        Me.PictureDisplay.Location = New System.Drawing.Point(288, 8)
        Me.PictureDisplay.Name = "PictureDisplay"
        Me.PictureDisplay.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.PictureDisplay.Size = New System.Drawing.Size(462, 588)
        Me.PictureDisplay.TabIndex = 1
        '
        'FileList
        '
        Me.FileList.BackColor = System.Drawing.SystemColors.Window
        Me.FileList.Cursor = System.Windows.Forms.Cursors.Default
        Me.FileList.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.FileList.ForeColor = System.Drawing.SystemColors.WindowText
        Me.FileList.IntegralHeight = False
        Me.FileList.ItemHeight = 16
        Me.FileList.Location = New System.Drawing.Point(8, 8)
        Me.FileList.Name = "FileList"
        Me.FileList.RightToLeft = System.Windows.Forms.RightToLeft.No
        Me.FileList.Size = New System.Drawing.Size(272, 584)
        Me.FileList.TabIndex = 0
        '
        'Form1
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(6, 16)
        Me.ClientSize = New System.Drawing.Size(759, 604)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.PictureDisplay, Me.FileList})
        Me.Font = New System.Drawing.Font("Arial", 8.0!, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, CType(0, Byte))
        Me.Location = New System.Drawing.Point(5, 38)
        Me.Name = "Form1"
        Me.Text = "OLEDragAndDrop - VB6"
        Me.ResumeLayout(False)

    End Sub
#End Region 
#Region "Upgrade Support "
	Private Shared m_vb6FormDefInstance As Form1
	Private Shared m_InitializingDefInstance As Boolean
	Public Shared Property DefInstance() As Form1
		Get
			If m_vb6FormDefInstance Is Nothing OrElse m_vb6FormDefInstance.IsDisposed Then
				m_InitializingDefInstance = True
				m_vb6FormDefInstance = New Form1()
				m_InitializingDefInstance = False
			End If
			DefInstance = m_vb6FormDefInstance
		End Get
		Set
			m_vb6FormDefInstance = Value
		End Set
	End Property
#End Region 
	
    Private Function EntryExists(ByVal filePath As String) As Boolean
        Dim file As String
        For Each file In FileList.Items
            If file.Equals(filePath) Then
                Return True
            End If
        Next
    End Function

    Private Sub SelectListItem(ByRef filePath As String)
        Dim i As Integer
        For i = 0 To FileList.Items.Count - 1
            If FileList.Items(i).Equals(filePath) Then
                FileList.SelectedIndex = i
            End If
        Next
    End Sub

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles MyBase.Load
        PictureDisplay.AllowDrop = True
        MsgBox("Drag pictures from the Windows File Explorer on to the right-hand panel to display and add to the listbox")

        Me.Show()
        Application.DoEvents()
        Shell("Explorer.exe " & VB6.GetPath & "\..\..\Pictures", AppWinStyle.NormalFocus)
    End Sub

    Private Sub PictureDisplay_DragDrop(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles PictureDisplay.DragDrop
        Debug.WriteLine("DragDrop")
        ' Clear out the existing image and ensure that any resources are released
        If Not PictureDisplay.Image Is Nothing Then
            PictureDisplay.Image.Dispose()
            PictureDisplay.Image = Nothing
        End If

        Dim files() As String = e.Data.GetData(DataFormats.FileDrop, True)

        Dim i As Integer
        For i = 0 To files.Length - 1
            If Not EntryExists(files(i)) Then
                FileList.SelectedIndex = FileList.Items.Add(files(i))
            Else
                SelectListItem(files(i))
            End If
        Next

        ' Set the picture to the last image added
        PictureDisplay.Image = Image.FromFile(FileList.SelectedItem)
    End Sub

    Private Sub PictureDisplay_DragEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DragEventArgs) Handles PictureDisplay.DragEnter
        Debug.WriteLine("DragEnter")
        If e.Data.GetDataPresent(DataFormats.FileDrop) Then

            Dim file() As String = e.Data.GetData(DataFormats.FileDrop, True)

            Dim ext As String = UCase(Microsoft.VisualBasic.Right(file(0), 4))
            'Dim ext As String = file(0).Substring(file(0).Length - 5, 4)

            Select Case ext
                Case ".BMP", ".JPG", ".GIF"
                    e.Effect = DragDropEffects.Copy
                Case Else
                    e.Effect = DragDropEffects.None
            End Select
        Else
            e.Effect = DragDropEffects.None
        End If
    End Sub

    Private Sub PictureDisplay_MouseDown(ByVal sender As Object, ByVal e As System.Windows.Forms.MouseEventArgs) Handles PictureDisplay.MouseDown
        Dim file(0) As String
        file(0) = FileList.SelectedItem

        Dim d As New DataObject(DataFormats.FileDrop, file)
        PictureDisplay.DoDragDrop(d, DragDropEffects.Copy)
    End Sub

    Private Sub FileList_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles FileList.SelectedIndexChanged
        If Not FileList.SelectedIndex = -1 Then
            If Not PictureDisplay.Image Is Nothing Then
                PictureDisplay.Image.Dispose()
                PictureDisplay.Image = Nothing
            End If

            PictureDisplay.Image = Image.FromFile(FileList.SelectedItem)
        End If
    End Sub

End Class