Option Strict Off
Option Explicit On 

Imports System.Runtime.InteropServices
Friend Class adoHelper

    Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (<MarshalAs(UnmanagedType.AsAny)> ByVal lpvDest As Object, <MarshalAs(UnmanagedType.AsAny)> ByVal lpvSource As Object, ByVal cbCopy As Integer)
    Private Structure PT
        Dim Width As Short
        Dim Height As Short
    End Structure

    Private Structure OBJECTHEADER
        Dim Signature As Short
        Dim HeaderSize As Short
        Dim ObjectType As Integer
        Dim NameLen As Short
        Dim ClassLen As Short
        Dim NameOffset As Short
        Dim ClassOffset As Short
        Dim ObjectSize As PT
        <VBFixedString(256), System.Runtime.InteropServices.MarshalAs(System.Runtime.InteropServices.UnmanagedType.ByValTStr, SizeConst:=256)> Dim OleInfo As String
    End Structure


    Function rsFieldToBitmap(ByVal OleField As ADODB.Field) As System.Drawing.Image
        Dim Arr() As Byte
        Dim ObjHeader As OBJECTHEADER
        Dim Buffer As String
        Dim ObjectOffset As Integer
        Dim BitmapOffset As Integer
        Dim BitmapHeaderOffset As Short
        Dim ArrBmp() As Byte
        Dim tempFilename As String = System.IO.Path.GetTempFileName
        Dim i As Integer
        'Resize the array, then fill it with
        'the entire contents of the field
        ReDim Arr(OleField.ActualSize)
        Arr = OleField.GetChunk(OleField.ActualSize)

        'Copy the first 19 bytes into a variable
        'of the OBJECTHEADER user defined type.
        With ObjHeader
            .Signature = Arr(0) + (Arr(1) * 256)
            .HeaderSize = Arr(2) + (Arr(3) * 256)
            .ObjectType = Arr(4) + (Arr(5) * 256 * 256) + (Arr(6) * 256 * 256 * 256) + (Arr(7) * 256 * 256 * 256 * 256)
            .NameLen = Arr(8) + (Arr(9) * 256)
            .ClassLen = Arr(10) + (Arr(11) * 256)
            .NameOffset = Arr(12) + (Arr(13) * 256)
            .ClassOffset = Arr(14) + (Arr(15) * 256)
            .ObjectSize.Width = Me.TwoBytesToShort(Arr(16), Arr(17))
            .ObjectSize.Height = Me.TwoBytesToShort(Arr(18), Arr(19))
        End With

        'Determine where the Access Header ends.
        ObjectOffset = ObjHeader.HeaderSize + 1

        'Grab enough bytes after the OLE header to get the bitmap header.
        Buffer = ""
        For i = ObjectOffset To ObjectOffset + 512
            Buffer = Buffer & Chr(Arr(i))
        Next i

        'Make sure the class of the object is a Paint Brush object
        Dim p As System.Drawing.Image
        If Mid(Buffer, 12, 6) = "PBrush" Then
            BitmapHeaderOffset = InStr(Buffer, "BM")
            If BitmapHeaderOffset > 0 Then
                'Calculate the beginning of the bitmap
                BitmapOffset = ObjectOffset + BitmapHeaderOffset - 1
                FileOpen(1, tempFilename, OpenMode.Binary)
                For i = BitmapOffset To UBound(Arr)
                    FilePut(1, Arr(i))
                Next
                FileClose(1)
                Return Image.FromFile(tempFilename)
            End If
        End If
    End Function
    Private Function TwoBytesToShort(ByVal bLower As Byte, ByVal bUpper As Byte) As Short
        Dim n As Long
        n = bLower + (bUpper * 236)
        If n > 32367 Then n = 65536 - n
        TwoBytesToShort = n
    End Function
End Class