Public Class Dashboard
    Inherits System.Windows.Forms.Form
    Structure SubFormStructure
        Dim AssemblyName As String
        Dim FormName As String
        Dim FormTitle As String
        Dim FormImage As Image
    End Structure
    Dim m_SubformArray() As SubFormStructure

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
    Friend WithEvents Label1 As System.Windows.Forms.Label
    Friend WithEvents Label2 As System.Windows.Forms.Label
        Private components As System.ComponentModel.IContainer

    'Required by the Windows Form Designer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Dim configurationAppSettings As System.Configuration.AppSettingsReader = New System.Configuration.AppSettingsReader()
        Me.Label1 = New System.Windows.Forms.Label()
        Me.Label2 = New System.Windows.Forms.Label()
        Me.SuspendLayout()
        '
        'Label1
        '
        Me.Label1.Location = New System.Drawing.Point(32, 24)
        Me.Label1.Name = "Label1"
        Me.Label1.Size = New System.Drawing.Size(408, 36)
        Me.Label1.TabIndex = 0
        Me.Label1.Text = "This form dynamically looks for child forms and displays them as buttons below"
        '
        'Label2
        '
        Me.Label2.Font = New System.Drawing.Font("Marlett", 14.25!, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, CType(2, Byte))
        Me.Label2.ForeColor = System.Drawing.Color.Maroon
        Me.Label2.Location = New System.Drawing.Point(6, 21)
        Me.Label2.Name = "Label2"
        Me.Label2.Size = New System.Drawing.Size(41, 30)
        Me.Label2.TabIndex = 1
        Me.Label2.Text = "4"
        '
        'Dashboard
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(6, 15)
        Me.ClientSize = New System.Drawing.Size(450, 333)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.Label1, Me.Label2})
        Me.Name = "Dashboard"
        Me.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen
        Me.Text = CType(configurationAppSettings.GetValue("Dashboard.Text", GetType(System.String)), String)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'Load an array of SubFormStructures with the list of available subforms
        GetSubForms()
        'Add a new button for each subform
        AddButtons()
    End Sub

    Sub AddButtons()
        '* This method adds a button and label for each subform
        Dim subFormCounter As Integer
        Dim myButton As Button, myLabel As Label
        'Loop though the array of subforms
        For subFormCounter = 1 To m_SubformArray.Length - 1
            'Add a button and label for each
            myButton = New Button()
            With myButton
                .Image = m_SubformArray(subFormCounter).FormImage
                .Location = New Point(15, subFormCounter * 60)
                .Size = New Size(56, 56)
                .FlatStyle = FlatStyle.Flat
                .Name = "subForm_" & subFormCounter
                'store the array index in the button's tag property
                .Tag = subFormCounter
            End With
            myLabel = New Label()
            With myLabel
                .Text = m_SubformArray(subFormCounter).FormTitle
                .Location = New Point(77, 20 + subFormCounter * 60)
                .AutoSize = True
                .Name = "subFormLabel_" & subFormCounter
            End With
            'Add the controls to the form
            Me.Controls.Add(myButton)
            Me.Controls.Add(myLabel)
            'Attach the Button_Click_Handler event to the Button's click event
            AddHandler myButton.Click, AddressOf Button_Click_Handler
        Next
    End Sub

    Sub GetSubForms()
        '* This method examines all the Dlls in the applicaiton's directory
        '* Each Windows Form in each DLL is added to the m_SubformArray array
        Dim filePathArray() As String
        Dim typeArray() As Type
        Dim fileCounter, typeCounter, totalForms As Integer
        Dim asm As Reflection.Assembly
        Dim f As Form
        ReDim m_SubformArray(0)
        '
        'Fill an array of strings with names of DLLs in the current directory
        filePathArray = System.IO.Directory.GetFiles(myDirectory(), "*.dll")
        '
        'loop through the DLLs and get the list of windows forms in the DLL
        For fileCounter = 0 To filePathArray.Length - 1
            'Load the assemble
            asm = asm.LoadFrom(filePathArray(fileCounter))
            'Get the list of types (classes) in the assembly
            typeArray = asm.GetTypes()
            'Loop through the types, examining each
            For typeCounter = 0 To typeArray.Length - 1
                'If its a form, then add it to our list
                If typeArray(typeCounter).BaseType.Name = "Form" Then
                    totalForms += 1
                    ReDim Preserve m_SubformArray(totalForms)
                    'We record the form's titlebar caption and icon for showing on the button
                    With m_SubformArray(totalForms)
                        .AssemblyName = typeArray(typeCounter).Assembly.Location
                        .FormName = typeArray(typeCounter).FullName
                        f = asm.CreateInstance(.FormName)
                        .FormTitle = f.Text
                        .FormImage = f.Icon.ToBitmap
                    End With
                End If
            Next typeCounter
        Next fileCounter
    End Sub

    Private Sub Button_Click_Handler(ByVal sender As System.Object, ByVal e As System.EventArgs)
        '* Dynamically load the appropriate form and show it
        Dim subFormIndex As Integer
        Dim asm As Reflection.Assembly
        Dim f As Form
        'The index into m_SubformArray was stored in the Tag property
        subFormIndex = sender.tag
        With m_SubformArray(subFormIndex)
            asm = asm.LoadFrom(.AssemblyName)
            f = CType(asm.CreateInstance(.FormName), Form)
            f.Show()
        End With
    End Sub

    Function myDirectory() As String
        '* This method returns the directory where the EXE is running
        Dim asm As Reflection.Assembly
        asm = Reflection.Assembly.GetExecutingAssembly()
        Return System.IO.Path.GetDirectoryName(asm.Location()) & "\"
    End Function

End Class