Imports System.Windows.Forms
Imports System.Drawing
Public Class GraphicsForm
    Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

    Public Sub New()
        MyBase.New()

        'This call is required by the Windows Form Designer.
        InitializeComponent()

        'Add any initialization after the InitializeComponent() call

    End Sub

    'Form overrides dispose to clean up the component list.
    Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
        If disposing Then
            If Not (components Is Nothing) Then
                components.Dispose()
            End If
        End If
        MyBase.Dispose(disposing)
    End Sub
                        Friend WithEvents alphaTimer As System.Windows.Forms.Timer
    Friend WithEvents HasOpacity As System.Windows.Forms.CheckBox
    Friend WithEvents HasDonutShape As System.Windows.Forms.CheckBox
    Friend WithEvents HasAlphaBlending As System.Windows.Forms.CheckBox
    Friend WithEvents box As System.Windows.Forms.GroupBox
    Friend WithEvents FadeInButton As System.Windows.Forms.Button
    Private components As System.ComponentModel.IContainer

    'Required by the Windows Form Designer

    'NOTE: The following procedure is required by the Windows Form Designer
    'It can be modified using the Windows Form Designer.  
    'Do not modify it using the code editor.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
        Me.components = New System.ComponentModel.Container()
        Dim resources As System.Resources.ResourceManager = New System.Resources.ResourceManager(GetType(GraphicsForm))
        Me.HasOpacity = New System.Windows.Forms.CheckBox()
        Me.box = New System.Windows.Forms.GroupBox()
        Me.HasAlphaBlending = New System.Windows.Forms.CheckBox()
        Me.HasDonutShape = New System.Windows.Forms.CheckBox()
        Me.alphaTimer = New System.Windows.Forms.Timer(Me.components)
        Me.FadeInButton = New System.Windows.Forms.Button()
        Me.box.SuspendLayout()
        Me.SuspendLayout()
        '
        'HasOpacity
        '
        Me.HasOpacity.Location = New System.Drawing.Point(17, 37)
        Me.HasOpacity.Name = "HasOpacity"
        Me.HasOpacity.Size = New System.Drawing.Size(153, 30)
        Me.HasOpacity.TabIndex = 0
        Me.HasOpacity.Text = "Form Opacity"
        '
        'box
        '
        Me.box.Controls.AddRange(New System.Windows.Forms.Control() {Me.HasAlphaBlending, Me.HasDonutShape, Me.HasOpacity})
        Me.box.Location = New System.Drawing.Point(10, 10)
        Me.box.Name = "box"
        Me.box.Size = New System.Drawing.Size(205, 168)
        Me.box.TabIndex = 0
        Me.box.TabStop = False
        Me.box.Text = "Graphics Effect"
        '
        'HasAlphaBlending
        '
        Me.HasAlphaBlending.Location = New System.Drawing.Point(17, 111)
        Me.HasAlphaBlending.Name = "HasAlphaBlending"
        Me.HasAlphaBlending.Size = New System.Drawing.Size(153, 30)
        Me.HasAlphaBlending.TabIndex = 2
        Me.HasAlphaBlending.Text = "Alpha Blending"
        '
        'HasDonutShape
        '
        Me.HasDonutShape.Location = New System.Drawing.Point(17, 74)
        Me.HasDonutShape.Name = "HasDonutShape"
        Me.HasDonutShape.Size = New System.Drawing.Size(153, 30)
        Me.HasDonutShape.TabIndex = 1
        Me.HasDonutShape.Text = "Donut Shape"
        '
        'alphaTimer
        '
        Me.alphaTimer.Interval = 40
        '
        'FadeInButton
        '
        Me.FadeInButton.Location = New System.Drawing.Point(88, 192)
        Me.FadeInButton.Name = "FadeInButton"
        Me.FadeInButton.Size = New System.Drawing.Size(123, 49)
        Me.FadeInButton.TabIndex = 1
        Me.FadeInButton.Text = "Fade In"
        '
        'GraphicsForm
        '
        Me.AutoScaleBaseSize = New System.Drawing.Size(6, 15)
        Me.ClientSize = New System.Drawing.Size(634, 293)
        Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.FadeInButton, Me.box})
        Me.Icon = CType(resources.GetObject("$this.Icon"), System.Drawing.Icon)
        Me.Name = "GraphicsForm"
        Me.Text = "Graphics Effects"
        Me.box.ResumeLayout(False)
        Me.ResumeLayout(False)

    End Sub

#End Region

    Private Sub alphaTimer_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles alphaTimer.Tick
        '* This event fades the word 'VB.NET' into 'Rocks!!'
        'The alpha variable determines with what transparency text is painted,
        'the updown variable determines whether the text is fading in or out
        Static alpha As Integer = 0, upDown As Integer = 2
        Dim g As Graphics
        Dim f As New Font("Arial Black", 60, FontStyle.Regular, GraphicsUnit.Pixel, 0)
        Dim tempBitmap As New Bitmap(300, 100)
        'cycle the alpha variable from 0 to 255 to 0 to 255, etc, etc
        alpha += upDown
        If alpha <= 0 Then
            upDown = -upDown
            alpha = 0
        ElseIf alpha >= 255 Then
            upDown = -upDown
            alpha = 255
        End If
        'We draw the two strings onto a temporary bitmap to avoid
        'screen flicker
        g = Graphics.FromImage(tempBitmap)
        g.Clear(Me.BackColor)
        g.DrawString("VB.NET", f, New SolidBrush(Color.FromArgb(255 - alpha, Color.DarkBlue)), New RectangleF(0, 0, 300, 100))
        g.DrawString("Rocks!!", f, New SolidBrush(Color.FromArgb(alpha, Color.Red)), 0, 0)
        g.Dispose()
        'Then draw the bitmap onto the form
        g = Me.CreateGraphics
        g.DrawImage(tempBitmap, 200, 10)
        g.Dispose()
        tempBitmap.Dispose()
        f.Dispose()
    End Sub

    Private Sub HasOpacity_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HasOpacity.CheckedChanged
        '* Toggle the transparency of the form. 
        '* 0.5 = half-transparent, 1 = Opaque
        If sender.Checked = True Then
            Me.Opacity = 0.5
        Else
            Me.Opacity = 1
        End If
    End Sub

    Private Sub HasAlphaBlending_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HasAlphaBlending.CheckedChanged
        '* Toggle the Timer that fades the 'VB.NET Rocks!!' text
        If sender.Checked() = True Then
            Me.alphaTimer.Enabled = True
        Else
            Me.alphaTimer.Enabled = False
            'If we are turning off the fade effect, then clear the background of the form
            Me.Refresh()
        End If
    End Sub

    Private Sub HasDonutShape_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles HasDonutShape.CheckedChanged
        '* Toggle the shape of the form
        If sender.Checked = True Then
            'This code sets the shape of the form by creating a
            'region (composed of paths). We then set the region of
            'the form to our newly created region
            Dim myPath As New Drawing2D.GraphicsPath()
            Dim bigDiameter As Integer = Me.ClientSize.Height
            Dim donutWidth As Integer = 80
            myPath.AddEllipse(0, 0, bigDiameter, bigDiameter)
            myPath.AddEllipse(donutWidth, donutWidth, bigDiameter - (donutWidth * 2), bigDiameter - (donutWidth * 2))
            Me.Region = New Region(myPath)
        Else
            Me.Region = Nothing
        End If
    End Sub

    Private Sub FadeInButton_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles FadeInButton.Click
        Dim d As Double
        For d = 0 To 1 Step 0.01
            Me.Opacity = d
            Me.Refresh()
            System.Threading.Thread.CurrentThread.Sleep(5)
        Next
        Me.HasOpacity.Checked = False
    End Sub

End Class
