Imports MyInterfaces
Imports System.Data
Imports System.Data.OleDb
Imports System.EnterpriseServices

'''''''''''''''''''''''''''''''''''''''''''''''''''''
'' The database class containing the implementation for the
'' INorthwindDatabase interface
Public Class Database
    Inherits ServicedComponent
    Implements MyInterfaces.INorthwindDatabase

    Dim conn As OleDbConnection
    Dim cmd As OleDbCommand
    Dim da As OleDbDataAdapter

    Public Sub New()
        conn = New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & Application.ExecutablePath & "\..\..\..\..\NWind.mdb")
        cmd = New OleDbCommand("", conn)
        da = New OleDbDataAdapter(cmd)
    End Sub

    Private Function ExecuteQuery(ByVal query As String) As DataTable
        Dim t As New DataTable()

        conn.Open()
        cmd.CommandText = query
        da.Fill(t)
        conn.Close()

        Return t
    End Function

    Public ReadOnly Property Categories() As DataTable Implements INorthwindDatabase.Categories
        Get
            Return ExecuteQuery("Select * From Categories")
        End Get
    End Property

    Public ReadOnly Property Customers() As DataTable Implements INorthwindDatabase.Customers
        Get
            Return ExecuteQuery("Select * From Customers")
        End Get
    End Property

    Public ReadOnly Property Employees() As DataTable Implements INorthwindDatabase.Employees
        Get
            Return ExecuteQuery("Select * From Employees")
        End Get
    End Property

    Public ReadOnly Property OrderDetails() As DataTable Implements INorthwindDatabase.OrderDetails
        Get
            Return ExecuteQuery("Select * From [Order Details]")
        End Get
    End Property

    Public ReadOnly Property Orders() As DataTable Implements INorthwindDatabase.Orders
        Get
            Return ExecuteQuery("Select * From Orders")
        End Get
    End Property

    Public ReadOnly Property Products() As DataTable Implements INorthwindDatabase.Products
        Get
            Return ExecuteQuery("Select * From Products")
        End Get
    End Property

    Public ReadOnly Property Shippers() As DataTable Implements INorthwindDatabase.Shippers
        Get
            Return ExecuteQuery("Select * From Shippers")
        End Get
    End Property

    Public ReadOnly Property Suppliers() As DataTable Implements INorthwindDatabase.Suppliers
        Get
            Return ExecuteQuery("Select * From Suppliers")
        End Get
    End Property
End Class
